some_variables:-
  G_RobotSpeed is 10, % pixels per second
  G_PutIn is 5,  % nice if PutIn=PullOut, PullOut > any time
  G_PullOut is 4,
  G_Miene is 20,
  G_No_crash_distance is 40/G_RobotSpeed, % 40 pixels

  G_Speedup is 40. % make the time go faster

%vana(N,    time,      name,      big vana,  pos, size, line)
vana( 1,       0,     "vhod",            1,   65, 15).      % predavane 0
vana( 2,       0,     "vhod",            2,   95, 15).
vana( 3,       0,     "sklad",           3,  120, 10, line).
vana( 4,       0,     "sklad",           3,  140, 10, line).
vana( 5,       0,     "sklad",           3,  160, 10, line).
vana( 6,       0,     "sklad",           3,  180, 10, line).
vana( 7,       0,     "sklad",           3,  200, 10, line).
vana( 8,       0,     "sklad",           3,  220, 10, line).
vana( 9,       0,     "sklad",           3,  240, 10, line).
vana(10,       0,     "sklad",           3,  260, 10).
vana(13,    2*60,     "obezmaslyavane", 13,  290, 20).
vana(14, G_Miene,     "miene",          14,  330, 20).
vana(15,       0,     "bayts",          15,  370, 20).
vana(16,   14*60,     "bayts",          15,  410, 20).      % middle 1, duplicates 2
vana(17, G_Miene,     "ikonomichno",    17,  450, 20).
vana(18, G_Miene,     "miene 1",        18,  490, 20, line).
vana(19, G_Miene,     "miene 2",        18,  530, 20).
vana(20,    2*60,     "reduktor",       20,  570, 20).      % predavane 1
vana(21, G_Miene,     "miene 1",        21,  610, 20, line).
vana(22, G_Miene,     "miene 2",        21,  650, 20).
vana(23,    4*60,     "aktivator",      23,  690, 20).      % middle 2, duplicates 1
vana(24, G_Miene,     "ikonomichno",    24,  730, 20).
vana(25, G_Miene,     "miene 1",        25,  770, 20, line).
vana(26, G_Miene,     "miene 2",        25,  810, 20).
vana(27, 5*60,        "Cu - Link",      27,  850, 20).      % predavane 2
vana(28, G_Miene,     "miene 1",        28,  890, 20, line).
vana(29, G_Miene,     "miene 2",        28,  930, 20).
vana(30,       0,     "Electo Cu",      30,  970, 20).
vana(31,       0,     "Electo Cu",      31, 1010, 20).
vana(32,       0,     "Electo Cu",      32, 1050, 20).
vana(33,   27*60,     "Electo Cu",      33, 1090, 20).      % middle 3, duplicates 4
vana(34, G_Miene,     "ikonomichno",    34, 1130, 20).
vana(35, G_Miene,     "miene 1",        35, 1170, 20, line).
vana(36, G_Miene,     "miene 2",        35, 1210, 20).
vana(37,      30,     "transportyor",   37, 1250, 20).      % predavane 3

main_initialisations:-

  % kade robotite si predavat topkata
  predavane(0) := 1,
  predavane(1) := 20,
  predavane(2) := 27,
  predavane(3) := 37,

  % kade e centralnata vana za vseki robot i vanite predi i sled neia
  wait_before(1) := 14, middle(1) := 16, wait_after(1) := 17,
  wait_before(2) := 22, middle(2) := 23, wait_after(2) := 24,
  wait_before(3) := 29, middle(3) := 33, wait_after(3) := 34,

  % kolko pati e dublirana centralnata vana
  duplicates(1) := 2,
  duplicates(2) := 1,
  duplicates(3) := 4.

  % kade sa robotite v parvia moment
rotos_are_at:-
  robot_pos(1) := vani_pos(wait_after(1)),
  robot_pos(2) := vani_pos(wait_before(2)),
  robot_pos(3) := vani_pos(wait_before(3)).

% tova tuk sa robotite
robot(1).
robot(2).
robot(3).

%big_vana(N,  name,             pos, size, color)
big_vana( 1, "vhod",             50,   15, G_BrushYellow).
big_vana( 2, "vhod",             80,   15, G_BrushYellow).
big_vana( 3, "sklad",           110,   80, G_BrushWhite).
big_vana(13, "obezmaslyavane",  270,   20, G_BrushPink).
big_vana(14, "miene",           310,   20, G_BrushMiene).
big_vana(15, "bayts",           350,   40, G_BrushBayts).
big_vana(17, "ikonomichno",     430,   20, G_BrushMiene).
big_vana(18, "miene 1-2",       470,   40, G_BrushMiene).
big_vana(20, "reduktor",        550,   20, G_BrushReduktor).
big_vana(21, "miene 1-2",       590,   40, G_BrushMiene).
big_vana(23, "aktivator",       670,   20, G_BrushAktivator).
big_vana(24, "ikonomichno",     710,   20, G_BrushMiene).
big_vana(25, "miene 1-2",       750,   40, G_BrushMiene).
big_vana(27, "Cu - Link",       830,   20, G_BrushCu).
big_vana(28, "miene 1-2",       870,   40, G_BrushMiene).
big_vana(30, "Electo Cu",       950,   20, G_BrushBlue).
big_vana(31, "Electo Cu",       990,   20, G_BrushBlue).
big_vana(32, "Electo Cu",      1030,   20, G_BrushBlue).
big_vana(33, "Electo Cu",      1070,   20, G_BrushBlue).
big_vana(34, "ikonomichno",    1110,   20, G_BrushMiene).
big_vana(35, "miene 1-2",      1150,   40, G_BrushMiene).
big_vana(37, "transportyor",   1230,   20, G_BrushYellow).

%____________________________
?-
  some_variables,
  G_Refresh_at is 0.1*G_Speedup,
  (G_Refresh_at<1 -> G_Refresh_at:=1),
  G_updates is 0,

  G_Time:=0,

  MaxRobots is 10,
  MaxVani is 50,
  array(strategy, MaxRobots, 0),
  array(vani_in_use, 4*MaxRobots, 0),
  array(white_part, 4*MaxRobots, 0.0),
  array(middle, MaxRobots, 0),
  array(duplicates, MaxRobots, 0),
  array(vani_time, MaxVani, 0.0),
  array(vani_pos, MaxVani, 0.0),
  array(stop_here, MaxVani, 0),
  array(go_to, MaxVani, 0),
  array(dont_hurry, 4*MaxVani, 0.0),
  array(vani_podveska, MaxVani, 0),
  array(vani_when, MaxVani, 0),
  array(robot_target, MaxRobots, 0),
  array(robot_podveska, MaxRobots, 0),
  array(robot_speed, MaxRobots, 0),
  robot_speed(1) := 10,
  robot_speed(2) := 10,
  robot_speed(3) := 10,

  array(predavane, MaxRobots, 0),
  array(wait_before, MaxRobots, 0),
  array(wait_after, MaxRobots, 0),
  array(robot_pos, MaxRobots, 0),
  array(time_r, 4*MaxRobots, 0.0),

  main_initialisations,
  init_vani,
  rotos_are_at,

  G_Red := font_mask(color(rgb(255,0,0))),
  G_Blue := font_mask(color(rgb(0,0,255))),
  calc_time_r0,
  calc_time_r1,
  calc_time_r2,
  calc_time_r3,

  G_Minimum1 := max(max(vani_time(predavane(1)), vani_time(predavane(2)))+G_PutIn+G_No_crash_distance,
                    max(max(vani_time(middle(1))/duplicates(1), vani_time(middle(2))/duplicates(2)), vani_time(middle(3))/duplicates(3))),
  G_Minimum  := G_Minimum1, nl,
  slowest_robot,
  choose_strategy,
  write(nl+"Minimum="+G_Minimum), nl,
  stabilisation,
  Bad_wait := 0,
  calc_Bad_wait(Bad_wait),
  write("Strategy ("+strategy(1)+", "+strategy(2)+", "+strategy(3)+"), Vani ("),
  type_vani(1), type_vani(2), type_vani(3), 
  write("), Bad_wait="+Bad_wait), nl,
  G_MainWin := window(title("Galvanic line"), size(1350, 428), paint_indirectly).

type_vani(R):-
  Vani is vani_in_use(4*R+strategy(R)),
  (Vani < duplicates(R) -> write(Vani, G_Red) else write(Vani)),
  (R<3 -> write(", ")).
  
slowest_robot:-
  Max := 0,
  slowest_robot(Max),
  (G_Minimum < Max ->
    G_Minimum  := Max,
    slowest_robot
  ).

slowest_robot(Max):-
  robot(R),
  Min := max_integer,
  quickest_strategy(R, Min),
  Max < Min,
  Max := Min,
  fail.
slowest_robot(Max).
  
quickest_strategy(R, Min):-
  for(Strategy, 0, 3),
  for( J, vani_in_use(4*R+Strategy), 1, step(-1)),
  A is (vani_time(middle(R))+ white_part(4*R+Strategy))/J,
  Black_wait is A-time_r(4*R+Strategy),
  B is (J=:=1 -> max_integer else A+Black_wait/(J-1)),
  G_Minimum =< B,
  Min >= A,
  Min := A,
  fail.
quickest_strategy(R, Min).

choose_strategy:-
  robot(R),
  Min := max_integer,
  choose_strategy(R, Min),
  (Min =:= max_integer ->
    write("No way", G_Red), nl
  ),
  fail.
choose_strategy.

choose_strategy(R, Min):-
  for(Strategy, 0, 3),
  for( J, vani_in_use(4*R+Strategy), 1, step(-1)),
  A is (vani_time(middle(R))+ white_part(4*R+Strategy))/J,
  Black_wait is A-time_r(4*R+Strategy),
  B is (J=:=1 -> max_integer else A+Black_wait/(J-1)),
  G_Minimum =< B,
  A =<G_Minimum,
  Bad_wait := dont_hurry(4*wait_before(R)+Strategy) + dont_hurry(4*wait_after(R)+Strategy)
               + J*(Strategy//2 + Strategy mod 2)*(G_Minimum-A),
  write("R"+R+": Strategy="+Strategy+", Bad_wait="+Bad_wait), nl,
  Min >= Bad_wait,
  Min := Bad_wait,
  strategy(R) := Strategy,
  vani_in_use(4*R+Strategy) := J,
  fail.
choose_strategy(R, Min).

win_func(init):-
  G_Next_podveska_starts_at := G_RobotSpeed*(11+from_to(1, wait_after(1))+G_PullOut),
  G_draw_diagram:=0,
  G_RedPen := pen(3, rgb(255, 0, 0)),
  G_GreenPen := pen(3, rgb(0, 255, 0)),
  G_BluePen := pen(3, rgb(0, 0, 255)),
  G_BlackPen := pen(1, 0),
  G_NoPen := pen(0, 0),
  G_BrushYellow := brush(rgb(255, 255, 0)),
  G_BrushWhite := brush(rgb(255, 255, 255)),
  G_BrushPink := brush(rgb(255, 200, 200)),
  G_BrushMiene := brush(rgb(0, 255, 255)),
  G_BrushBayts := brush(rgb(120, 60, 0)),
  G_BrushReduktor := brush(rgb(0, 255, 0)),
  G_BrushAktivator := brush(rgb(80, 40, 0)),
  G_BrushCu := brush(rgb(0, 128, 0)),
  G_BrushBlue := brush(rgb(0, 0, 255)),
  G_BrushSystem := brush(system_color(window)),
  chronometer(),
  _ is set_timer(_, (1/G_Speedup)/G_RobotSpeed, time_func),
  G_Check_Box := check_box( class(check_func), text("Feed up"), pos(50, 245), size(180, 20)), % checked
  set_check_box_value(G_Check_Box, 1),
  check_box( class(check_func_diagram), text("Show diagram"), pos(500, 245), size(180, 20)).

win_func(paint):-
  get_paint_rect(A,B,C,D),
  (D>260, G_draw_diagram=:=1 ->
    Mashtab is 1/2,
    Bold is 2,
    draw_diagram(Mashtab, Bold),
    pen(G_BlackPen),
    line(0, 269, 1350, 269),
    line(Mashtab*G_Minimum1, 269, Mashtab*G_Minimum1, 269+9*4*(Bold+1)),
    line(Mashtab*G_Minimum, 269, Mashtab*G_Minimum, 269+9*4*(Bold+1))
  ),
  G_updates:=G_updates+1,
  draw_big_vana(_),
  fail.
win_func(paint):-
  color_text_back(_, rgb(255, 255, 255)),
  robot(Robot),
  draw_robot(Robot, new),
  fail.

win_func(close):-
  write(nl+nl+"Real_time="+chronometer()+", Line_time/Speedup="+(G_Time/G_Speedup)/G_RobotSpeed+", updates="+G_updates+nl),
  fail.

check_func(press) :-
  set_check_box_value(_,1-get_check_box_value(_)).

check_func_diagram(press) :-
  G_draw_diagram:=1-G_draw_diagram,
  set_check_box_value(_,G_draw_diagram),
  update_window(G_MainWin, rect(0,266,1350,600)).

draw_diagram(Mashtab, Bold):-
  robot(R),
  (R=:=1-> pen(G_GreenPen) else (R=:=2-> pen(G_RedPen) else pen(G_BluePen))),
  for(Strategy, 0, 3),
  for( J, duplicates(R), 1, step(-1)),
  A is (vani_time(middle(R))+ white_part(4*R+Strategy))/J,
  Black_wait is A-time_r(4*R+Strategy),
  Black_wait>=0,
  B is (J=:=1 -> 1350 else Mashtab*(A+Black_wait/(J-1))),
  for(I, 0, Bold),
  line(Mashtab*A, 270-12*(Bold+1)+3*((Bold+1)*(4*R+Strategy)+I), B, 270-12*(Bold+1)+3*((Bold+1)*(4*R+Strategy)+I)),
  fail.
draw_diagram(_, _).

time_func(end) :-
  G_Time:=G_Time+1,
  (G_Time mod G_Refresh_at =:=0->
    update_window(_, rect(0,0,1350,240))
  ),
  (vani_podveska(37)>0, vani_when(37)<G_Time ->
    vani_podveska(37) := 0
    %draw_big_vana(37)
  ),
  (G_Next_podveska_starts_at<G_Time+G_RobotSpeed*(from_to(1, wait_after(1))+G_PullOut)->
    G_Next_podveska_starts_at := G_Next_podveska_starts_at + G_RobotSpeed*G_Minimum
  ),
  feed_up(1),
  feed_up(2),
  robot(Robot),
  (robot_speed(Robot)=:=0->
    (robot_target(Robot)>0->
      robot_target(Robot):=robot_target(Robot)-1
    else
      Pos := robot_pos(Robot),
      vana(Vana, _, _, Big, Pos|_),
      (robot_podveska(Robot)>0->
        vani_podveska(Vana):=robot_podveska(Robot),
        (vani_time(Vana)>0->
          vani_when(Vana):=G_Time+G_RobotSpeed*(vani_time(Vana)+dont_hurry(4*Vana+strategy(Robot)))
        ),
        robot_podveska(Robot):=0,
        wait_here_or_move(Robot, Vana)
        % write(nl+vani_podveska(Vana)+" in "+Vana+" from R"+Robot+" at "+(G_Time/G_RobotSpeed)) 
      else (vani_podveska(Vana)>0->
        robot_podveska(Robot):=vani_podveska(Vana),
        vani_podveska(Vana):=0,
        goto_next_vana(Robot),
        write(nl+robot_podveska(Robot)+" out "+Vana+" from R"+Robot+" at "+(G_Time/G_RobotSpeed)),
        (Vana=\=1->
          Diff is (G_Time-vani_when(Vana))/G_RobotSpeed,
          write(" after "+(Diff+vani_time(Vana)+dont_hurry(4*Vana+strategy(Robot)))),
          (Diff>0->
            write(" error="+Diff, G_Red)
          else (Diff+dont_hurry(4*Vana+strategy(Robot))>0->
            write(" diff="+(Diff+dont_hurry(4*Vana+strategy(Robot))), G_Blue)
          ))
        )
      %else robot_speed(Robot):=10
      ))
      %draw_big_vana(Big),
      %draw_robot(Robot, new)
    )
  else (robot_speed(Robot)=\=10->
    %draw_robot(Robot, old),
    robot_pos(Robot):= robot_pos(Robot)+robot_speed(Robot),
    (robot_target(Robot)=:=robot_pos(Robot)->
      Pos := robot_pos(Robot),
      vana(Vana, _, _, Big, Pos|_),
      robot_speed(Robot):=0,
      (robot_podveska(Robot)>0->
        robot_target(Robot):=G_RobotSpeed*G_PutIn-1
      else (vani_podveska(Vana)>0, vani_when(Vana)=<G_Time+G_RobotSpeed*G_PullOut->
        robot_target(Robot):=G_RobotSpeed*G_PullOut-1 %, write(nl+G_Time+"   "+vani_when(Vana), G_Blue)
      else
        robot_speed(Robot):=10,
        where_next_to_go(Robot)
      ))
    )
    %draw_robot(Robot, new)
  else % 10, i.e. wait
    where_next_to_go(Robot)
  )),
  fail.

feed_up(Vana):-
  (vani_podveska(Vana)=:=0, vani_when(Vana)<G_Time-(0+10*Vana)*G_RobotSpeed, get_check_box_value(G_Check_Box)=:=1->
    vani_podveska(Vana):=10+random(90),
    vani_when(Vana):= G_Next_podveska_starts_at-(1-Vana)*G_RobotSpeed*from_to(1, 2),
    G_Next_podveska_starts_at := G_Next_podveska_starts_at + G_RobotSpeed*G_Minimum
    %draw_big_vana(1)
  ).

where_next_to_go(Robot):-
  find_where_next_to_go(Robot, S, When),
  (When<max_integer, When=<G_Time+abs(vani_pos(S)-robot_pos(Robot))+G_RobotSpeed*G_PullOut->
    robot_target(Robot):=(vani_pos(S)=:=robot_pos(Robot)-> G_RobotSpeed*G_PullOut-1 else vani_pos(S)),
    robot_speed(Robot):= sign(vani_pos(S)-robot_pos(Robot)) %, write(nl+G_Time, G_Red)
  else
    Pos := robot_pos(Robot),
    vana(Vana, _, _, _, Pos |_),
    do_extra_job(Robot, Vana, S, When)
  ),
  fail.
where_next_to_go(Robot).

start(2).
start(1).

do_extra_job(Robot, Vana, S, When):-
  Robot=1, Vana=<13,
  start(Start),
  Start =\= S,
  vani_podveska(Start)>0,
  find_first_empty(Start, End, 10),
  End > 2,
  When>G_Time + G_RobotSpeed*(from_to(Vana, Start)+G_PullOut+from_to(Start, End)+G_PutIn+from_to(End, S)),
  !,
  robot_target(Robot):=(vani_pos(Start)=:=robot_pos(Robot)-> G_RobotSpeed*G_PullOut-1 else vani_pos(Start)),
  robot_speed(Robot):= sign(vani_pos(Start)-robot_pos(Robot)),
  go_to(Start) := End,
  vani_when(End) := vani_when(Start)+G_RobotSpeed*from_to(Start, End),
  vani_when(Start) := G_Time + G_RobotSpeed*(from_to(Vana, Start)+G_PullOut). 


find_where_next_to_go(Robot, Vana, When):-
  When := max_integer,
  Vana :=0,
  possible_next(Robot, S), 
  (vani_podveska(S)>0, vani_when(S) < When ->
    When := vani_when(S),
    Vana := S
  ),
  fail.
find_where_next_to_go(Robot, Vana, When).  

possible_next(Robot, S):-
  for(S, predavane(Robot-1), predavane(Robot)-1).

wait_here_or_move(Robot, Vana):-
  (predavane(Robot)=:=Vana->
    (strategy(Robot)>0, strategy(Robot)<3; Robot=:=1; vani_time(predavane(Robot-1))>=from_to(predavane(Robot-1), wait_after(Robot))+G_PullOut ->
      robot_target(Robot):=vani_pos(wait_after(Robot))
    else
      robot_target(Robot):=vani_pos(predavane(Robot-1)+1)
    ),
    robot_speed(Robot):= -1
  else
    robot_speed(Robot):= 10,
    where_next_to_go(Robot)
  ).

goto_next_vana(Robot):-
  Pos := robot_pos(Robot),
  vana(Vana, _, _, _, Pos|_),
  (go_to(Vana)>0->
    Next is go_to(Vana),
    go_to(Vana) := 0
  else
    next_vana(Vana, Vana, Next, Robot)
  ),
  robot_target(Robot):=vani_pos(Next),
  robot_speed(Robot):= sign(robot_target(Robot)-robot_pos(Robot)).

next_vana(Vana1, Vana, I, Robot):-
  Next is Vana+1,
  (wait_before(Robot)<Vana1, Vana1<wait_after(Robot) ->
    I is wait_after(Robot)
  else (stop_here(Next)=:=1; Next=:=predavane(Robot)->
    find_first_empty(Vana1, I, Next)
  else
    next_vana(Vana1, Next, I, Robot)
  )).

find_first_empty(Vana1, I, Next):-
  (will_be_empty_for(Next, Vana1)->
    I is Next
  else
    Next2 is Next-1,
    find_first_empty(Vana1, I, Next2)
  ).

will_be_empty_for(Next, Vana):-
  vani_podveska(Next)=:=0;
  vani_when(Next) < G_Time + G_RobotSpeed*(from_to(Vana, Next) + G_No_crash_distance + G_PullOut).

draw_big_vana(Big):-
  big_vana( Big, _, Pos, Size, Brush),
  pen(G_RedPen),
  brush(Brush),
  rect(Pos, 50, Pos+2*Size, 200),
  pen(G_BlackPen),
  vana( N, _, _, Big, Pos2, Size2|Line),
  color_text_back(_, rgb(200, 200, 200)),
  text_out(print(N), pos(Pos2-7, 70) ),
  (vani_podveska(N)>0->
    color_text_back(_, rgb(255, 255, 255)),
    text_out(print(vani_podveska(N) ), pos(Pos2-7, 130) )
  ),
  (Line=[line]->
    line(Pos2+Size2, 50, Pos2+Size2, 200)
  ).

draw_robot(Robot, New):-
  (New=new->
    pen(G_BlackPen),
    brush(G_BrushYellow),
    fill_polygon(robot_pos(Robot)-20, 20, robot_pos(Robot), 49, robot_pos(Robot)+20, 20),
    (robot_podveska(Robot)>0->
      color_text_back(_, rgb(255, 255, 255)),
      text_out(print(robot_podveska(Robot)), pos(robot_pos(Robot)-5, 25) )
    ),
    fill_polygon(robot_pos(Robot)-20, 230, robot_pos(Robot), 200, robot_pos(Robot)+20, 230)
  else
    pen(G_NoPen),
    brush(G_BrushSystem),
    rect(robot_pos(Robot)-22, 20, robot_pos(Robot)+22, 51),
    rect(robot_pos(Robot)-22, 200, robot_pos(Robot)+22, 232)
  ).

R is from_to(A, B):-
  R := abs(vani_pos(B)-vani_pos(A))/G_RobotSpeed.

calc_time_r0:-
  write("Direct:"), nl,
  robot(R),
  calc_time_r0(R).
calc_time_r0.

calc_time_r0(R):-
  for(J, duplicates(R), 1, step(-1)),
  time_r(4*R+0) := 2*from_to(predavane(R-1), predavane(R))
             + (J>1 -> 2*from_to(middle(R)-1, middle(R)) else 0)
             + 2*(G_PullOut+G_PutIn),
  colect_times(time_r(4*R+0), predavane(R-1)+1, wait_before(R)),
  colect_times(time_r(4*R+0), wait_after(R), predavane(R)-1),
  white_part(4*R+0) := time_r(4*R+0)- (J=:=1 -> 0 else from_to(middle(R)-1, middle(R))),
  % Black_wait is vani_time(middle(R)), % if J=:=1
  Black_wait is (vani_time(middle(R))+white_part(4*R+0))/J-time_r(4*R+0),
  White_wait is (J=:=1 -> "inf" else Black_wait/(J-1)),
  Black_wait>=0, !,
  vani_in_use(4*R+0) := J,
  write("R"+R+"="+(time_r(4*R+0)+Black_wait)+", vani="+J+", Black_wait="+Black_wait
       +", White_wait < "+ White_wait
       +", Bad_wait=0"), nl,
  fail.

calc_time_r1:-
  nl, write("Wait before:"), nl,
  robot(R),
  calc_time_r1(R).
calc_time_r1.

calc_time_r1(R):-
  for(J, duplicates(R), 1, step(-1)),
  Go_and_back := 2*from_to(wait_before(R), predavane(R))
               + 2*G_PullOut+G_PutIn,
  colect_times(Go_and_back, wait_after(R), predavane(R)-1),
  % (Go_and_back<vani_time(wait_before(R))->
  Add1 := vani_time(wait_before(R)) - Go_and_back,
  (Add1<0 ->
    dont_hurry(4*wait_before(R)+1):= 0-Add1,
    Add1 := 0
  else
    dont_hurry(4*wait_before(R)+1):= 0
  ),
  time_r(4*R+1) := Go_and_back + 2*from_to(predavane(R-1), middle(R))
                           + Add1 + G_PullOut+2*G_PutIn,
  colect_times(time_r(4*R+1), predavane(R-1)+1, wait_before(R)-1),
  white_part(4*R+1) := Go_and_back+G_PutIn-G_PullOut,
  Black_wait is (vani_time(middle(R))+white_part(4*R+1))/J-time_r(4*R+1),
  White_wait is (J=:=1 -> "inf" else Black_wait/(J-1)),
  Black_wait>=0, !,
  vani_in_use(4*R+1) := J,
  write("R"+R+"="+(time_r(4*R+1)+Black_wait)+", vani="+J+", Black_wait="+Black_wait
       +", White_wait < "+ White_wait
       +", Bad_wait="+dont_hurry(4*wait_before(R)+1)+"+"+J+"*White_wait"), nl,
  fail.

calc_time_r2:-
  nl, write("Wait after:"), nl,
  robot(R),
  calc_time_r2(R).
calc_time_r2.

calc_time_r2(R):-
  for(J, duplicates(R), 1, step(-1)),
  Go_and_back := 2*from_to(predavane(R-1), wait_after(R))
               + 2*G_PullOut+G_PutIn,
  colect_times(Go_and_back, predavane(R-1)+1, wait_before(R)),
  % (Go_and_back<vani_time(wait_after(R))->
  Add2 := vani_time(wait_after(R)) - Go_and_back,
  (Add2<0 ->
    dont_hurry(4*wait_after(R)+2):= 0-Add2,
    Add2 := 0
  else
    dont_hurry(4*wait_after(R)+2):= 0
  ),
  time_r(4*R+2) := Go_and_back + 2*from_to(wait_after(R)-J, predavane(R))
                           + Add2 + G_PullOut+2*G_PutIn,
  colect_times(time_r(4*R+2), wait_after(R)+1, predavane(R)-1),
  white_part(4*R+2) := Go_and_back+G_PutIn-G_PullOut,
  Black_wait is (vani_time(middle(R))+ white_part(4*R+2))/J-time_r(4*R+2),
  White_wait is (J=:=1 -> "inf" else Black_wait/(J-1)),
  Black_wait>=0, !,
  vani_in_use(4*R+2) := J,
  write("R"+R+"="+(time_r(4*R+2)+Black_wait)+", vani="+J+", Black_wait="+Black_wait
       +", White_wait < "+ White_wait
       +", Bad_wait="+dont_hurry(4*wait_after(R)+2)+"+"+J+"*White_wait"), nl,
  fail.

calc_time_r3:-
  nl, write("No wait:"), nl,
  robot(R),
  calc_time_r3(R).
calc_time_r3.

calc_time_r3(R):-
  for(J, duplicates(R), 1, step(-1)),
  Go_and_back is 2*from_to(wait_before(R), wait_after(R))+2*G_PullOut+G_PutIn,
  Add1 := vani_time(wait_before(R)) - Go_and_back,
  (Add1<0 ->
    dont_hurry(4*wait_before(R)+3):= 0-Add1,
    Add1 := 0
  else
    dont_hurry(4*wait_before(R)+3):= 0
  ),
  Add2 := vani_time(wait_after(R)) - Go_and_back,
  (Add2<0 ->
    dont_hurry(4*wait_after(R)+3):= 0-Add2,
    Add2 := 0
  else
    dont_hurry(4*wait_after(R)+3):= 0
  ),
  time_r(4*R+3) := 2*from_to(predavane(R-1), wait_before(R))
             + 2*from_to(wait_after(R), predavane(R))
             + 2*(G_PullOut+G_PutIn)
             + Add1 + Add2 + 2*Go_and_back-2*G_PullOut,
  colect_times(time_r(4*R+3), predavane(R-1)+1, wait_before(R)-1),
  colect_times(time_r(4*R+3), wait_after(R)+1, predavane(R)-1),
  white_part(4*R+3) := Go_and_back+G_PutIn-G_PullOut,
  Black_wait is (vani_time(middle(R))+ white_part(4*R+3))/J-time_r(4*R+3),
  White_wait is (J=:=1 -> "inf" else Black_wait/(J-1)),
  Black_wait>=0, !,
  vani_in_use(4*R+3) := J,
  write("R"+R+"="+(time_r(4*R+3)+Black_wait)+", vani="+J+", Black_wait="+Black_wait
       +", White_wait < "+ White_wait
       +", Bad_wait="+(dont_hurry(4*wait_before(R)+3)+dont_hurry(4*wait_after(R)+3))
       +"+"+2*J+"*White_wait"), nl,
  fail.

stabilisation:-
  robot(R),
  Diff is G_Minimum-(vani_time(middle(R))+ white_part(4*R+strategy(R)))/vani_in_use(4*R+strategy(R)),
  (strategy(R)/\1=:=1 ->
    dont_hurry(4*wait_before(R)+strategy(R)) := dont_hurry(4*wait_before(R)+strategy(R)) + Diff*vani_in_use(4*R+strategy(R))
  ),
  (strategy(R)/\2=:=2 ->
    dont_hurry(4*wait_after(R)+strategy(R)) := dont_hurry(4*wait_after(R)+strategy(R)) + Diff*vani_in_use(4*R+strategy(R))
  ),
  write("R"+R+": Diff="+Diff+", dont_hurry: before="+dont_hurry(4*wait_before(R)+strategy(R))+", after="+dont_hurry(4*wait_after(R)+strategy(R))), nl,
  fail.
stabilisation.

calc_Bad_wait(Bad_wait):-
  robot(R),
  Bad_wait := Bad_wait + dont_hurry(4*wait_before(R)+strategy(R)) + dont_hurry(4*wait_after(R)+strategy(R)),
  fail.
calc_Bad_wait(Bad_wait).

colect_times(Where, A, B):-
  for(I, A, B),
    Where := Where+stop_here(I)*(vani_time(I)+G_PutIn), % nice if PutIn=PullOut
  fail.
colect_times(Where, A, B).

init_vani:-
  vana( N, Time, _, _, Pos|_),
  vani_pos(N):=Pos,
  Time>0,
  (N=\=predavane(1), N=\=predavane(2)->
    vani_time(N) := max(G_PullOut, Time)
  else
    vani_time(N) := max(G_PullOut+G_No_crash_distance, Time)
  ),
  stop_here(N):=1,
  fail.
init_vani:-
  robot(R),
  for(I, middle(R)-duplicates(R)+1, middle(R)-1),
  vani_time(I):=vani_time(middle(R)),
  fail.
init_vani.

