#!./strawberry

include("banners.pro").

?-
  X is scan(get_environment_arg(0, getenv("QUERY_STRING"))),
  go(X).

go(new):-
  Variant is random(10000),
  G_X1=no,
  G_X2=no,
  say(Variant, 0, 1, "Click one of the blocks to open it.").

go(X):-
  start_random_from(X),
  add_icon2(0),
  add_icon2(1),
  add_icon2(2),
  add_icon2(3),
  add_icon2(4),
  add_icon2(5),
  add_icon2(6),
  add_icon2(7),
  add_icon2(8),
  add_icon2(9),
  add_icon2(10),
  add_icon2(11),
  add_icon2(12),
  add_icon2(16),
  add_icon2(17),
  start_random_from(_),
  Sit is scan(get_environment_arg(1, getenv("QUERY_STRING"))),
  C is scan(get_environment_arg(2, getenv("QUERY_STRING"))),
  mouse_click(C, X, Sit).

mouse_click(0, Variant, Sit):-
  G_X1=no,
  G_X2=no,
  say(Variant, Sit, 1, "Click one of the blocks to open it.").

mouse_click(1, Variant, Sit):-
  G_X1 is scan(get_environment_arg(3, getenv("QUERY_STRING"))),
  G_Y1 is scan(get_environment_arg(4, getenv("QUERY_STRING"))),
  G_X2=no,
  say(Variant, Sit, 2, "Open the same picture.").

mouse_click(2, Variant, Sit):-
  G_X1 is scan(get_environment_arg(3, getenv("QUERY_STRING"))),
  G_Y1 is scan(get_environment_arg(4, getenv("QUERY_STRING"))),
  G_X2 is scan(get_environment_arg(5, getenv("QUERY_STRING"))),
  G_Y2 is scan(get_environment_arg(6, getenv("QUERY_STRING"))),
  ico(Icon1, G_X1, G_Y1),
  ico(Icon2, G_X2, G_Y2),
  if_equal(Icon1, Icon2, Variant, Sit).

if_equal(Icon, Icon, Variant, Sit) :-
  Sit2 is Sit+ (1 << Icon),
  (Sit2=204799 ->
  say(Variant, Sit2, 1, "Congratulations, you are the winner!");
  say(Variant, Sit2, 1, "Well, now open another block.") ).

if_equal(_, _, Variant, Sit) :-
  say(Variant, Sit, 0, "Sorry, but this is not the same picture.").

add_icon(Ico):-  X is random(12)//2,
  Y is random(5),
  not(ico(_,X,Y)),
  assert(ico(Ico,X,Y)), !.

add_icon(Ico):-
  add_icon(Ico).

add_icon2(Ico):-
  add_icon(Ico),
  add_icon(Ico).

say(Variant, Sit, Click, Message):- 
  set_content_type("text/html"),
  write("<!doctype html public ""-//w3c//dtd html 4.0 transitional//en""> 
<html> 
<head> 
   <meta http-equiv=""Content-Type"" content=""text/html; charset=windows-1251""> 
   <meta name=""Author"" content=""Dimiter Dobrev""> 
   <meta name=""GENERATOR"" content=""Mozilla/4.51 [en] (Win98; I) [Netscape]""> 
   <title>Memory Blocks 6x5</title> 
</head> 
<body text=""#FFFFCC"" bgcolor=""#282848"" link=""#FF0000"" vlink=""#FF9900"" alink=""#FFCC33"">"), 
 
  banner,
 
 write("<p> 
<center><table BORDER=0 CELLSPACING=0 CELLPADDING=0 COLS=6 WIDTH=""1%"" >"), 
  for(Y, 0, 4), 
  write(" 
<tr>"), 
  for(X, 0, 5), 
  write(" 
<td>"),
  link(Variant, Sit, Click, Icon, X, Y), 
  write("<img SRC=""/games/c"), 
  write(Icon), 
  write(".gif"" BORDER=0 height=40 width=40></a></td>"), 
  X=5, 
  write(" </tr> 
"), 
  Y=4, 
  write(" 
</table></center> 
 
<center> 
<p>"),
write("<center><font size=+1>"),
write(Message),
write("</font></center><br><br><br>"),
( (Sit=0) ->
 write("<img src=""/games/NewGame_dn.gif"" alt=""New Game"">");
 write("<a href=""/cgi-bin/MemBlocks.pro?new""><img src=""/games/NewGame_up.gif"" alt=""New Game"" border=0></a>") ),
write("<a href=""/games.html""><img src=""/games/BacktoGames_up.gif"" alt=""Back To Games"" border=0></a>"),
write("<a href=""/games/Rules_MemBlocks.html""><img src=""/games/Rules_up.gif"" alt=""Rules"" border=0></a>"),
write("<a href=""http://www.dobrev.com""><img src=""/games/SP_up.gif"" alt=""Strawberry Prolog"" border=0></a>"),
write("<p><b><font color=""#33CCFF""><font size=+3>Memory Blocks 6x5</font></font></b></center>
<p><br><br><br>"),

 banner,

write("
</body>
</html> 
 
"). 
 
link(_, Sit, _, Icon, X, Y):-
  ico(Icon, X, Y),
  R is Sit/\ (1 << Icon),
  R\=0, !.

link(_, _, Click, Icon, X, Y):-
  X=G_X1,
  Y=G_Y1, !,
  ico(Icon, X, Y).

link(_, _, Click, Icon, X, Y):-
  X=G_X2,
  Y=G_Y2, !,
  ico(Icon, X, Y).

link(Variant, Sit, Click, f, X, Y):- !,
  write("<a href=""/cgi-bin/MemBlocks.pro?"), 
  write(Variant), 
  write("&"), 
  write(Sit), 
  write("&"), 
  write(Click),
  click2(Click),
  click1(Click, X, Y),
  write(""">"). 
click2(2):- !,
  write("&"),
  write(G_X1),
  write("&"), 
  write(G_Y1).
click2(_).

click1(Click, X, Y):-   Click>0, !,
  write("&"),
  write(X), 
  write("&"),
  write(Y).
click1(_,_,_).

