% This program demonstrates work with ODBC (deleting data from Database)
% Created by Plamen Sharapanov

?-
  getCnnString(STR_Cnn),
  open_db(STR_Cnn, Obj_cnn),
  Obj_cnn.execute("delete * from country"),
  write(`The "country" table is cleaned!`), nl.


% uncomment your DB Source:
getCnnString("Provider=Microsoft.Jet.OLEDB.4.0;Data Source="+this_program_path+"\\db.mdb").
%getCnnString(`Provider=MSDASQL.1;Extended Properties="DBQ=`+this_program_path+`\\db.xls;Driver={Microsoft Excel Driver (*.xls)};"`).


open_db(STR_Cnn, Obj_cnn) :-
  write("--open_db--"),nl,
  Obj_cnn is server("ADODB.Connection"),
  Obj_cnn."ConnectionString" :=  STR_Cnn,
  Obj_cnn."open"().

