% This program demonstrates work with ODBC (inserting data to Database)
% Created by Plamen Sharapanov

?-
  getCnnString(STR_Cnn),
  open_db(STR_Cnn, Obj_cnn),
  insert_all(Obj_cnn).


% uncomment your DB Source:
getCnnString("Provider=Microsoft.Jet.OLEDB.4.0;Data Source="+this_program_path+"\\db.mdb").
%getCnnString(`Provider=MSDASQL.1;Extended Properties="DBQ=`+this_program_path+`\\db.xls;Driver={Microsoft Excel Driver (*.xls)};"`).


open_db(STR_Cnn, Obj_cnn) :-
  write("--open_db--"), nl,
  Obj_cnn is server("ADODB.Connection"),
  Obj_cnn.'ConnectionString' := STR_Cnn,
  Obj_cnn.open().

insert_all(Obj_cnn) :-
  c(X,Y),
  write("--insert: "),write(X),write(", '" ),write(Y),write("'"),nl,
  Obj_cnn.execute("insert into country(country_code,country_name) values("+X+",'"+Y+"')"),
  fail.
insert_all(_).


c(2,"Afghanistan").
c(3,"Albania").
c(4,"Algeria").
c(5,"American Samoa").
c(6,"Andorra").
c(7,"Angola").
c(8,"Anguilla").
c(9,"Antarctica").
c(10,"Antigua and Barbuda").
c(11,"Argentina").
c(12,"Armenia").
c(13,"Aruba").
c(14,"Australia").
c(15,"Austria").
c(16,"Azerbaijan").
c(17,"Bahamas").
c(18,"Bahrain").
c(19,"Bangladesh").
c(20,"Barbados").
c(21,"Belarus").
c(22,"Belgium").
c(23,"Belize").
c(24,"Benin").
c(25,"Bermuda").
c(26,"Bhutan").
c(27,"Bolivia").
c(28,"Bosnia and Herzegovina").
c(29,"Botswana").
c(30,"Bouvet Island").
c(31,"Brazil").
c(32,"British Indian Ocean Territory").
c(33,"Brunei Darussalam").
c(34,"Bulgaria").
c(35,"Burkina Faso").
c(36,"Burma").
c(37,"Burundi").
c(38,"Cambodia").
c(39,"Cameroon").
c(40,"Canada").
c(41,"Canton and Enderbury Islands").
c(42,"Cape Verde").
c(43,"Cayman Islands").
c(44,"Central African Republic").
c(45,"Chad").
c(46,"Chile").
c(47,"China").
c(48,"Christmas Island").
c(49,"Cocos (Keeling) Islands").
c(50,"Colombia").
c(51,"Comoros").
c(52,"Congo").
c(53,"Cook Islands").
c(54,"Costa Rica").
c(55,"Cote D''Ivoire"). % ' is replaced with ''
c(56,"Croatia (Hrvatska)").
c(57,"Cuba").
c(58,"Cyprus").
c(59,"Czech Republic").
c(60,"Democratic Yemen").
c(61,"Denmark").
c(62,"Djibouti").
c(63,"Dominica").
c(64,"Dominican Republic").
c(65,"Dronning Maud Land").
c(66,"East Timor").
c(67,"Ecuador").
c(68,"Egypt").
c(69,"El Salvador").
c(70,"Equatorial Guinea").
c(71,"Eritrea").
c(72,"Estonia").
c(73,"Ethiopia").
c(74,"Falkland Islands (Malvinas)").
c(75,"Faroe Islands").
c(76,"Fiji").
c(77,"Finland").
c(78,"France").
c(79,"France, Metropolitan").
c(80,"French Guiana").
c(81,"French Polynesia").
c(82,"French Southern Territories").
c(83,"Gabon").
c(84,"Gambia").
c(85,"Georgia").
c(86,"Germany").
c(87,"Ghana").
c(88,"Gibraltar").
c(89,"Greece").
c(90,"Greenland").
c(91,"Grenada").
c(92,"Guadeloupe").
c(93,"Guam").
c(94,"Guatemala").
c(95,"Guinea").
c(96,"Guinea-bisseu").
c(97,"Guyana").
c(98,"Haiti").
c(99,"Heard and Mc Donald Islands").
c(100,"Honduras").
c(101,"Hong Kong").
c(102,"Hungary").
c(103,"Iceland").
c(104,"India").
c(105,"Indonesia").
c(106,"Iran (Islamic Republic of)").
c(107,"Iraq").
c(108,"Ireland").
c(109,"Israel").
c(110,"Italy").
c(111,"Ivory Coast").
c(112,"Jamaica").
c(113,"Japan").
c(114,"Johnston Island").
c(115,"Jordan").
c(116,"Kazakstan").
c(117,"Kenya").
c(118,"Kiribati").
c(119,"Korea, North").
c(120,"Korea, South").
c(121,"Kuwait").
c(122,"Kyrgyzstan").
c(123,"Lao PDR").
c(124,"Latvia").
c(125,"Lebanon").
c(126,"Lesotho").
c(127,"Liberia").
c(128,"Libyan Arab Jamahiriya").
c(129,"Liechtenstein").
c(130,"Lithuania").
c(131,"Luxembourg").
c(132,"Macau").
c(133,"Macedonia").
c(134,"Madagascar").
c(135,"Malawi").
c(136,"Malaysia").
c(137,"Maldives").
c(138,"Mali").
c(139,"Malta").
c(140,"Marshall Islands").
c(141,"Martinique").
c(142,"Mauritania").
c(143,"Mauritius").
c(144,"Mayotte").
c(145,"Mexico").
c(146,"Micronesia, Federated States of").
c(147,"Midway Islands").
c(148,"Moldova ").
c(149,"Monaco").
c(150,"Mongolia").
c(151,"Montserrat").
c(152,"Morocco").
c(153,"Mozambique").
c(154,"Myanmar").
c(155,"Namibia").
c(156,"Nauru").
c(157,"Nepal").
c(158,"Netherlands").
c(159,"Netherlands Antilles").
c(160,"Neutral Zone").
c(161,"New Calidonia").
c(162,"New Zealand").
c(163,"Nicaragua").
c(164,"Niger").
c(165,"Nigeria").
c(166,"Niue").
c(167,"Norfolk Island").
c(168,"Northern Mariana Islands").
c(169,"Norway").
c(170,"Oman").
c(171,"Pacific Islands").
c(172,"Pakistan").
c(173,"Palau").
c(174,"Panama").
c(175,"Papua New Guinea").
c(176,"Paraguay").
c(177,"Peru").
c(178,"Philippines").
c(179,"Pitcairn Island").
c(180,"Poland").
c(181,"Portugal").
c(182,"Puerto Rico").
c(183,"Qatar").
c(184,"Reunion").
c(185,"Romania").
c(186,"Russian Federation").
c(187,"Rwanda").
c(188,"S. Georgia and S. Sandwich Isls.").
c(189,"Saint Lucia").
c(190,"Saint Vincent/Grenadines").
c(191,"Samoa").
c(192,"San Marino").
c(193,"Sao Tome and Principe").
c(194,"Saudi Arabia").
c(195,"Senegal").
c(196,"Seychelles").
c(197,"Sierra Leone").
c(198,"Singapore").
c(199,"Slovakia (Slovak Republic)").
c(200,"Slovenia").
c(201,"Solomon Islands").
c(202,"Somalia").
c(203,"South Africa").
c(204,"Spain").
c(205,"Sri Lanka").
c(206,"St. Helena").
c(207,"St. Kitts Nevis Anguilla").
c(208,"St. Pierre and Miquelon").
c(209,"Sudan").
c(210,"Suriname").
c(211,"Svalbard and Jan Mayen Islands").
c(212,"Swaziland").
c(213,"Sweden").
c(214,"Switzerland").
c(215,"Syran Arab Republic").
c(216,"Taiwan").
c(217,"Tajikistan").
c(218,"Tanzania, United Republic of").
c(219,"Thailand").
c(220,"Togo").
c(221,"Tokelau").
c(222,"Tonga").
c(223,"Trinidad and Tobago").
c(224,"Tunisia").
c(225,"Turkey").
c(226,"Turkmenistan").
c(227,"Turks and Caicos Islands").
c(228,"Tuvalu").
c(229,"US Minor Outlying Islands").
c(230,"Uganda").
c(231,"Ukraine").
c(232,"United Arab Emirates").
c(233,"United Kingdom").
c(234,"United States").
c(235,"United States Pacific Islands").
c(236,"Upper Volta").
c(237,"Uruguay").
c(238,"Uzbekistan").
c(239,"Vanuatu").
c(240,"Vatican City State").
c(241,"Venezuela").
c(242,"VietNam").
c(243,"Virgin Islands, British").
c(244,"Virgin Islands, Unites States").
c(245,"Wake Island").
c(246,"Wallis and Futuma Islands").
c(247,"Western Sahara").
c(248,"Yemen").
c(249,"Yugoslavia").
c(250,"Zaire").
c(251,"Zambia").
c(252,"Zimbabwe").

